function Create(self)

	GetMehmanKeys();
	self.recoil = 0;
	self.ff = false;
	self.f0 = ToMagazine(self.Magazine).RoundCount;
	self.f1 = ToMagazine(self.Magazine).RoundCount;
	

	self.Mags = {};
	self.Mags[0] = "Magazine Viking Plasma";
	self.Mags[1] = "Magazine Viking DHE";
	self.Mags[2] = "Magazine Viking HO";
	self.TotalMags = 3;
	self.Recoils = {};
	self.Recoils[0] = 0.5250;
	self.Recoils[1] = 0.4525;
	self.Recoils[2] = 0.2575;
	
	self.recoilpershot = self.Recoils[0];
	self.recoilvariation = 0.125;
	self.recoilrecovery = 0.00825;

	self.RRCrouchScalar = 1.75;
	self.RRZeroVelScalar = 1.5;


	self.Sharpness = 0;
	self.GetsHitByMOS = true;

	--laser:
	self.Range = 1750;
	self.t = Timer();

	self.ioi = false;
	self.i1 = 0;
	self.i2 = 0;

	
end

function Update(self)
	
	--recoil
	self.ioi = not self.ioi;

	if self.Magazine ~= nil then
		if self.ff then
			self.f0 = ToMagazine(self.Magazine).RoundCount;
			self.ff = false;
		else
			self.f1 = ToMagazine(self.Magazine).RoundCount;
			self.ff = true;
		end

		if MovableMan:IsActor(self.Parent) then
			self.RecoilResistance = 1+((ToActor(self.Parent).Mass/100)*(ToActor(self.Parent).Health/100));
			if self.PresetName == "MEW Soldier" then self.RecoilResistance = self.RecoilResistance*1.25 end
			if ToActor(self.Parent).Vel.Magnitude < 2 then
				self.RecoilResistance = self.RecoilResistance*self.RRZeroVelScalar;
			end
			if ToActor(self.Parent):GetController():IsState(6) then
				self.RecoilResistance = self.RecoilResistance*self.RRCrouchScalar;
			end
			if self:IsActivated() and self.f1 ~= self.f0 then
				self.recoil = self.recoil+((self.recoilpershot+(math.random(-1000*self.recoilvariation,1000*self.recoilvariation)/1000))/self.RecoilResistance);
			end
		end

	end

	if self.HFlipped then
		self.RotAngle = self.RotAngle-self.recoil;
	else
		self.RotAngle = self.RotAngle+self.recoil;
	end
	
	if self.recoil > 0 then
		self.recoil = self.recoil - self.recoilrecovery;
	end
	

	self.Parent = MovableMan:GetMOFromID(self.RootID);
	if MovableMan:IsActor(self.Parent) then
		if ToActor(self.Parent):IsPlayerControlled() and UInputMan:KeyPressed(MehmanKey0) then
			if self.Sharpness < self.TotalMags-1 then
				self.Sharpness = self.Sharpness+1;
			else
				self.Sharpness = 0;
			end
		end
	end


	if self:IsReloading() then
		self.recoilpershot = self.Recoils[Round(self.Sharpness)];
		self.recoil = 0.0;
	end
	self:SetNextMagazineName(self.Mags[Round(self.Sharpness)]);
	

	if MovableMan:IsActor(self.Parent) then
		if ToActor(self.Parent):IsPlayerControlled() and UInputMan:KeyPressed(MehmanKey0) then
			self.Team = MovableMan:GetMOFromID(self.RootID).Team;
			local mo = SceneMan:ShortestDistance(self.Pos, self.MuzzlePos, true);
			local p = Vector();
			local ray = SceneMan:CastObstacleRay(self.MuzzlePos+mo, Vector(self.Range*mo.Normalized.X,self.Range*mo.Normalized.Y), Vector(), p, self.ID, 0, 3, 0);

			if ray > 0 then
				local k = CreateMOPixel("LasGun Particle 18");
				k.Team = self.Team;
				k.Pos = p;
				k.Vel = Vector(0,0);
				MovableMan:AddMO(k);

				local j = CreateTDExplosive("Artillery strike target designator2");
				j:Activate();
				j.Team = self.Team;
				j.Pos = p-mo;
				j.Vel = Vector(0,0);
				MovableMan:AddMO(j);
			end

			self.t:Reset();
		end
	end

	local mo = SceneMan:ShortestDistance(self.Pos, self.MuzzlePos, true);
	local p = Vector();
	local ray = SceneMan:CastObstacleRay(self.MuzzlePos+mo, Vector(self.Range*mo.Normalized.X,self.Range*mo.Normalized.Y), Vector(), p, self.ID, -6, 0, 0);

	if ray > 0 then
		local k = CreateMOPixel("Little Laser Glow Green");
		k.Team = self.Team;
		k.Pos = p;
		k.Vel = Vector(0,0);
		MovableMan:AddMO(k);
		local k2 = CreateMOPixel("Little Laser Glow Green");
		k.Team = self.Team;
		k2.Pos = p;
		k2.Vel = Vector(0,0);
		MovableMan:AddMO(k2);
	end
end

function Destroy(self)
end

function PLBulletsPie(actor)
	local gun = ToAHuman(actor).EquippedItem;
	if gun ~= nil then
		local gun = ToHDFirearm(gun);
		if Round(gun.Sharpness) ~= 0 then
			gun.Sharpness = 0;
			gun:Reload();
		end
	end
end

function HEDBulletsPie(actor)
	local gun = ToAHuman(actor).EquippedItem;
	if gun ~= nil then
		local gun = ToHDFirearm(gun);
		if Round(gun.Sharpness) ~= 1 then
			gun.Sharpness = 1;
			gun:Reload();
		end
	end
end

function HOBulletsPie(actor)
	local gun = ToAHuman(actor).EquippedItem;
	if gun ~= nil then
		local gun = ToHDFirearm(gun);
		if Round(gun.Sharpness) ~= 2 then
			gun.Sharpness = 2;
			gun:Reload();
		end
	end
end

