function Update(self)
   for p in MovableMan.Particles do
      local vect = p.Pos - self.Pos
      local dist = vect.Magnitude
      if dist <= 80 then
         local ang = vect.AbsRadAngle
         local vang = p.Vel.AbsRadAngle
         if math.abs(ang - vang) < math.pi/2 then
            local imp = vect * p.Mass * 2 * p.Vel.Magnitude
            local zero = Vector(0, 0)
            p:AddAbsImpulseForce(imp, zero)
         end
      end
   end
end