function Create(self)


	self.Attached = false;
	self.DetonationTime = 1000;
	self.DetonationRange = 100;
	self.Sharpness = 125;
	local ray = SceneMan:CastMORay(self.Pos, self.Vel.Normalized*10 , self.ID, self.Team , 128 , false , 0);
	if ray ~= 255 then
		local mo = MovableMan:GetMOFromID(ray);
		if mo.Team ~= self.Team and MovableMan:IsOfActor(ray) then
			self.Target = ToActor(MovableMan:GetMOFromID(mo.RootID));
			self.Offset = SceneMan:ShortestDistance(self.Target.Pos, self.Pos, true);
			self.Angle = math.atan2(self.Offset.Y,self.Offset.X);
			self.TargetFlipped = self.Target.HFlipped;
			self.Offset = self.Offset.Magnitude;
			self.Attached = true;
		end
	end
	

	
end

function Update(self)
if self.Target == nil then

	end
	if self.Attached and MovableMan:IsActor(self.Target) then
			self.Vel = self.Target.Vel;
			local aangle = self.Angle+self.Target.RotAngle;
			local off = 0;
			if self.Target.HFlipped ~= self.TargetFlipped then
				off = Vector(-math.cos(aangle),math.sin(aangle))*self.Offset;
			else
				off = AngleToVec(aangle)*self.Offset;
			end
			self.Pos = self.Target.Pos+off;
	end
	
	if self.Age > self.DetonationTime then
		for particle in MovableMan.Particles do
			local dist = SceneMan:ShortestDistance(particle.Pos, self.Pos, true);
			if dist.Magnitude < self.DetonationRange then
				if particle.PresetName == self.PresetName then
					ToMOSRotating(particle):GibThis();
				end
			end
		end
	end
			
	
end
