function Create(self)

	self.Vel = self.Vel.Normalized*math.random(98,106);
	self.Sharpness = 50;
	self.ParticleNumber = 32;
	self.PNum = self.ParticleNumber;
	self.Life = 1000;
	self.PartVel = 8;
	self.EffectVel = 8;
	self.EffectNum = 4;
	self.EffectIV = 0.975;
	self.SHARPNESS = 1750;
	self.MINSHARPNESS = 500;
	
end

function Update(self)
	self.PNum = self.ParticleNumber*(1-(self.Age/self.Life));
	if self.PNum < 1 then self.ToDelete = true; end
	local ray = SceneMan:CastObstacleRay(self.Pos , self.Vel*1.05*TimerMan.DeltaTimeSecs*GetPPM() , Vector() , Vector() , self.ID , self.Team, 0 , 1);
	if ray > 0 or self.ToDelete == true then
		while self.PNum > 0 do
      		local lr = CreateMOPixel("Plasma");
     		lr.Pos = self.Pos+((self.Vel/125)*ray);
      		lr.Vel = RandVector2(0,self.PartVel);
			lr.Sharpness =  math.random(self.MINSHARPNESS,self.SHARPNESS);
      		MovableMan:AddMO(lr);
			self.PNum = self.PNum-1;
			
			local lr2 = CreateMOPixel("Little Plasma Glow");
			lr2.Pos = self.Pos;
			lr2.Vel = RandVector2(0,self.EffectVel)+self.Vel;
			MovableMan:AddMO(lr2);

		end
		self.ToDelete = true;
	end
	
	local effn = self.EffectNum*(1-(self.Age/self.Life));--*self.PNum/self.ParticleNumber;
	local i = 0;
	while i < effn and self.Age > TimerMan.DeltaTimeMS do
		local lr = CreateMOPixel("Little Plasma Glow");
		lr.Pos = self.Pos-self.Vel*TimerMan.DeltaTimeSecs*GetPPM()*(i/effn);
		lr.Vel = self.Vel*(self.EffectIV+(1-self.EffectIV)*(i/effn));
		MovableMan:AddMO(lr);
		i = i+1;
	end
	
end
